#include <core>
#include <console>
#include <string>
#include <admin>
#include <adminlib>

new STRING_VERSION[MAX_DATA_LENGTH]="19.05.03";

#define BAD_WORD 	100
#define SANCTION	6

new g_BadWordsCFG[MAX_TEXT_LENGTH]="addons/adminmod/config/chatfilter/badwords.cfg";
new g_iBadWords;

new g_BadWords[BAD_WORD][MAX_TEXT_LENGTH];
new g_BWAnswer[BAD_WORD][MAX_TEXT_LENGTH];
new g_BWWarnPoints[BAD_WORD][MAX_NUMBER_LENGTH];
new g_Warning[MAX_PLAYERS];

new g_slap;
new g_slay;
new g_kick;
new g_ban;
new g_ban_min;

public HSay(HLCommand,HLData,HLUserName,UserIndex) {
	new Data[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
	new i;
	
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,User,MAX_DATA_LENGTH);
	
	strstripquotes(Data);
	
	if(strlen(Data)!=0){
		for(i=0;i<=g_iBadWords;i++){
			if(strcasestrx(Data,g_BadWords[i])!=-1){
				sanction(User,UserIndex,i);
				return PLUGIN_HANDLED;
				break;
			}
		}
		
	}	
	return PLUGIN_CONTINUE;
}

sanction(UserName[],UserIndex,ArrayIndex){
	new Text[MAX_TEXT_LENGTH];
	new warning;
	messageex(UserName,g_BWAnswer[ArrayIndex],print_chat);
	warning=strtonum(g_BWWarnPoints[ArrayIndex]);
	if(warning>0){
		g_Warning[UserIndex]+=warning;
		if(g_Warning[UserIndex]<g_slap){
			snprintf(Text,MAX_TEXT_LENGTH,"Du hast jetzt %i. Strafpunkt(e). Ab %i wird geslapt!",g_Warning[UserIndex],g_slap);
			messageex(UserName,Text,print_chat);
		}else if(g_Warning[UserIndex]>=g_slap && g_Warning[UserIndex]<g_slay){
			snprintf(Text,MAX_TEXT_LENGTH,"Du hast jetzt %i. Strafpunkte! Resultat: SLAP! Ab %i Punkten wirst Du aussetzen!",g_Warning[UserIndex],g_slay);
			slap(UserName);
			messageex(UserName,Text,print_chat);
		}else if(g_Warning[UserIndex]>=g_slay && g_Warning[UserIndex]<g_kick){
			snprintf(Text,MAX_TEXT_LENGTH,"Du hast jetzt %i. Strafpunkte! Resultat: SLAY! Ab %i Punkten kommt der KICK!",g_Warning[UserIndex],g_kick);
			slay(UserName);
			messageex(UserName,Text,print_chat);
		}else if(g_Warning[UserIndex]>=g_kick && g_Warning[UserIndex]<g_ban){
			snprintf(Text,MAX_TEXT_LENGTH,"Du hast %i. Strafpunkte erreicht! Resultat: KICK! Du hast es ja nicht anders gewollt!",g_Warning[UserIndex]);
			messageex(UserName,g_BWAnswer[ArrayIndex],print_console);
			messageex(UserName,Text,print_console);
			kick(UserName);
		}else if(g_Warning[UserIndex]>=g_ban){
			snprintf(Text,MAX_TEXT_LENGTH,"Du hast %i. Strafpunkte erreicht! Resultat: BAN! Du hast es ja nicht anders gewollt!",g_Warning[UserIndex]);
			messageex(UserName,g_BWAnswer[ArrayIndex],print_console);
			messageex(UserName,Text,print_console);
			ban(UserName,g_ban_min,bBanByID);
		}
	}
}

public plugin_disconnect(HLUserName,UserIndex) {
	g_Warning[UserIndex]=0;
	return PLUGIN_CONTINUE;
}
	
public plugin_connect(HLUserName,HLIP, UserIndex) {
	g_Warning[UserIndex]=0;
	return PLUGIN_CONTINUE;
}

read_files(){
	new Data[MAX_TEXT_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	new i;
	new j;
	
	if(fileexists(g_BadWordsCFG)){
		g_iBadWords=0;
		j=filesize(g_BadWordsCFG);
		if(j>99){
			j=99;
		}
		for(i=1;i<=j;i++){
			readfile(g_BadWordsCFG,Data,i,MAX_TEXT_LENGTH);
			strsplit(Data,":",g_BadWords[i],MAX_TEXT_LENGTH,g_BWAnswer[i],MAX_TEXT_LENGTH,g_BWWarnPoints[i],MAX_NUMBER_LENGTH);
			g_iBadWords++;
		}
		snprintf(Text,MAX_TEXT_LENGTH,"[SDAL-CHAT-FILTER] Es wurden %i Woerter und Antworten geladen!",g_iBadWords);
		selfmessage(Text);
	}else{
		selfmessage("[SDAL-CHATFILTER] Konnte Filter-Datei nicht finden! Bitte kontrollieren");
	}
	return PLUGIN_CONTINUE;
}

public plugin_init() {
	plugin_registerinfo("SDals Chat Filter V3","It filters the bad words and reacts correspondingly to it",STRING_VERSION);
	plugin_registercmd("say","HSay",ACCESS_ALL);
	plugin_registercmd("say_team","HSay",ACCESS_ALL);
	read_files();
	get_vaultnumdata("CHATFILTER_SLAP",g_slap);
	get_vaultnumdata("CHATFILTER_SLAY",g_slay);
	get_vaultnumdata("CHATFILTER_KICK",g_kick);
	get_vaultnumdata("CHATFILTER_BAN",g_ban);
	get_vaultnumdata("CHATFILTER_BAN_MIN",g_ban_min);
	return PLUGIN_CONTINUE;
}			
			

